#!/usr/bin/python
from subprocess import Popen, PIPE
from optparse import OptionParser
import os,sys

abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")

parser = OptionParser()
parser.add_option("-d", "--debug",   dest="debug", default=False, action='store_true',
                                    help="debug option to show detail commands to test")
parser.add_option("--csv",   dest="csv", default=False, action='store_true', help="csv format")
(opts, args) = parser.parse_args()

def main():

   dev_map={}
   command="ls -lL /dev/mapper/* /dev/sd* /dev/md* | grep disk"
   for line in get_printout(command):
      sgs=line.split()
      dev_map[sgs[len(sgs)-1]]="dev%s-%s" %( (sgs[4])[:-1],sgs[5] )
   #print dev_map

   device_name=""
   dev_name_backups=get_first_word("mount | grep -E 'backups'")
   dev_name_stateless=get_first_word("mount | grep -E 'Stateless'")
   db_dev_name=get_first_word("mount | grep '/var/opt/unitrends/database'")
   if len(db_dev_name) and "md" not in db_dev_name:
      db_dev_name=db_dev_name[:-1]

   if len(dev_name_backups):
      #print "/backups mounted on %s" % dev_name_backups, dev_map[dev_name_backups]
      device_name=dev_name_backups

   if len(dev_name_stateless):
      #print "/stateless mounted on %s" % dev_name_stateless, dev_map[dev_name_stateless]
      device_name=dev_name_stateless

   if not len(device_name):
      print "No device found"
      return

   if not os.path.exists("/var/log/sa"):
      print "No sar file found"
      return

   deviceList=[(device_name,"D2D")]
   if len(db_dev_name):
      deviceList.append( (db_dev_name,"DB") )

   get_result(dev_map,deviceList)

def get_result(dev_map,deviceList):       
   import datetime
   now=datetime.datetime.now()
   sum_rdMB,sum_wrMB,sum_util,count,last_day_util,last_week_util=0,0,0,0,0,0
   #for i in range(1,29):
   #for i in range(28,0,-1):
   for i in range(1,2):
      then=now -datetime.timedelta(days=i)
   
      sa_file="/var/log/sa/sa%02d" % then.day
      if os.path.exists(sa_file):
         outputs=get_printout("/usr/bin/sar -f %s | grep 'Average' | /usr/bin/tail -1" % sa_file)
         # if sar file is healthy and good:
         if len(outputs):
            ## CPU 
            json_out = "{"
            json_out+= "\"date\": \"%s\", " %then.date()

            sgs=outputs[0].split()
            json_out+= "\"CPU\" : {"
            json_out+= "\"user\": \"%d\", "   %int(0.5+float(sgs[2]))
            json_out+= "\"nice\": \"%d\", "   %int(0.5+float(sgs[3]))
            json_out+= "\"system\": \"%d\", " %int(0.5+float(sgs[4]))
            json_out+= "\"iowait\": \"%d\", " %int(0.5+float(sgs[5]))
            json_out+= "\"idle\": \"%d\", "   %int(0.5+float(sgs[7]))
            json_out+= "},"

            ## block
            command="/usr/bin/sar -b -f %s | grep 'Average' | /usr/bin/tail -1" % sa_file
            outputs=get_printout(command)
            sgs=outputs[0].split()
            json_out+= "\"Block\" : {"
            json_out+= "\"tps\": \"%d\", "     %int(0.5+float(sgs[1]))
            json_out+= "\"rtps\": \"%d\", "    %int(0.5+float(sgs[2]))
            json_out+= "\"wtps\": \"%d\", "    %int(0.5+float(sgs[3]))
            json_out+= "\"breadps\": \"%d\", " %int(0.5+float(sgs[4]))
            json_out+= "\"bwrtnps\": \"%d\", " %int(0.5+float(sgs[5]))
            json_out+= "},"

            ## Page
            outputs=get_printout("/usr/bin/sar -B -f %s | grep 'Average' | /usr/bin/tail -1" % sa_file)
            sgs=outputs[0].split()
            json_out+= "\"Page\" : {"
            json_out+= "\"pginps\": \"%d\", "    %int(0.5+float(sgs[1]))
            json_out+= "\"pgoutps\": \"%d\", "   %int(0.5+float(sgs[2]))
            json_out+= "\"faultps\": \"%d\", "   %int(0.5+float(sgs[3]))
            json_out+= "\"majfltps\": \"%d\", "  %int(0.5+float(sgs[4]))
            json_out+= "\"pgfreeps\": \"%d\", "  %int(0.5+float(sgs[5]))
            json_out+= "\"pgscankps\": \"%d\", " %int(0.5+float(sgs[6]))
            json_out+= "\"pgscandps\": \"%d\", " %int(0.5+float(sgs[7]))
            json_out+= "\"pgstealps\": \"%d\", " %int(0.5+float(sgs[8]))
            json_out+= "\"vmeff\": \"%d\", "     %int(0.5+float(sgs[9]))
            json_out+= "},"

            ## Queue and Load
            outputs=get_printout("/usr/bin/sar -q -f %s | grep 'Average' | /usr/bin/tail -1" % sa_file)
            sgs=outputs[0].split()
            json_out+= "\"Queue\" : {"
            json_out+= "\"runq-sz\": \"%d\", "   %int(0.5+float(sgs[1]))
            json_out+= "\"plist-sz\": \"%d\", "  %int(0.5+float(sgs[2]))
            json_out+= "\"ldavg-1\": \"%d\", "   %int(0.5+float(sgs[3]))
            json_out+= "\"ldavg-5\": \"%d\", "   %int(0.5+float(sgs[4]))
            json_out+= "\"ldavg-15\": \"%d\", "  %int(0.5+float(sgs[5]))
            json_out+= "},"

            ## Memory
            outputs=get_printout("/usr/bin/sar -r -f %s | grep 'Average' | /usr/bin/tail -1" % sa_file)
            sgs=outputs[0].split()
            json_out+= "\"Memory\" : {"
            json_out+= "\"kbmemfree\": \"%d\", "   %int(sgs[1])
            json_out+= "\"kbmemused\": \"%d\", "   %int(sgs[2])
            json_out+= "\"memused\": \"%d\", "     %int(0.5+float(sgs[3]))
            json_out+= "\"kbbuffers\": \"%d\", "   %int(sgs[4])
            json_out+= "\"kbcached\": \"%d\", "    %int(sgs[5])
            json_out+= "\"kbcommit\": \"%d\", "    %int(sgs[6])
            json_out+= "\"commitperc\": \"%d\", "  %int(0.5+float(sgs[7]))
            json_out+= "},"

            ## Network
            outputs=get_printout("/usr/bin/sar -n DEV -f %s | grep 'Average'" % sa_file)
            json_out+= "\"Network\" : {"

            for out in outputs:
               sgs=out.split()
               json_out+="\"%s\" : {" %sgs[1]
               json_out+= "\"rxpckps\": \"%d\", "   %int(0.5+float(sgs[2]))
               json_out+= "\"txpckps\": \"%d\", "   %int(0.5+float(sgs[3]))
               json_out+= "\"rxkBps\" : \"%d\", "   %int(0.5+float(sgs[4]))
               json_out+= "\"txkBps\" : \"%d\", "   %int(0.5+float(sgs[5]))
               json_out+= "\"rxcmpps\": \"%d\", "   %int(0.5+float(sgs[6]))
               json_out+= "\"txcmpps\": \"%d\", "   %int(0.5+float(sgs[7]))
               json_out+= "\"rxmcstps\": \"%d\", "  %int(0.5+float(sgs[8]))
               json_out+= "},"
            json_out+= "},"
            
            
            for givenDevice in deviceList:
               device_name=givenDevice[0]
               label=givenDevice[1]

               json_out+= "\"Device_%s\" : {" %label
               tps_day,rdMB_day,wrMB_day,avgrq_sz_day,avgqu_sz_day,await_day,svctm_day,util_day=0,0,0,0,0,0,0,0
               if "md" in device_name:
                  devices,short =[],device_name.split("/")[2]
                  device_list   ="" #"%s"%dev_map[device_name]
                  words=(get_printout("grep '%s ' /proc/mdstat" %short)[0]).split()
                  for word in words:
                     if "sd" in word:
                        devices.append(word[0:3])
                        device_list+="|%s"%dev_map["/dev/%s"%word[0:3]]
      
                  #print device_list
                  command="/usr/bin/sar -d -f %s | grep 'Average' | grep -E '%s'" % (sa_file,device_list)
                  #print command
                  outputs=get_printout(command)
   
                  rdMB,wrMB,util,count=0,0,0,len(outputs)
                  tps,avgrq_sz,avgqu_sz,await,svctm=0,0,0,0,0
                  for out in outputs:
                     sgs=out.split()
                     tps +=float(sgs[2])
                     rdMB+=float(sgs[3])
                     wrMB+=float(sgs[4])
                     avgrq_sz +=float(sgs[5])
                     avgqu_sz +=float(sgs[6])
                     await    +=float(sgs[7])
                     svctm +=float(sgs[8])
                     util+=float(sgs[9])

                  tps_day  =int(0.5+tps/float(count))
                  rdMB_day=int(0.5+int(rdMB*3600*24/float(count)+0.5)*0.5/1024.)
                  wrMB_day=int(0.5+int(wrMB*3600*24/float(count)+0.5)*0.5/1024.)
                  avgrq_sz_day =int(0.5+avgrq_sz/float(count))
                  avgqu_sz_day =int(0.5+avgqu_sz/float(count))
                  await_day =int(0.5+await/float(count))
                  svctm_day =int(0.5+svctm/float(count))
                  util_day=int(0.5+util/float(count))
   
               else:
                  command="/usr/bin/sar -d -f %s | grep 'Average' | grep %s | /usr/bin/tail -1" \
                                     % (sa_file,dev_map[device_name])
                  if opts.debug: print command
                  lines=get_printout(command)
                  sar_output=lines[len(lines)-1]
                  sgs=sar_output.split()
                  
                  tps_day  =int(0.5+float(sgs[2]))
                  rdMB_day =int(0.5+int(float(sgs[3])*3600*24+0.5)*0.5/1024.)
                  wrMB_day =int(0.5+int(float(sgs[4])*3600*24+0.5)*0.5/1024.)
                  avgrq_sz_day  =int(0.5+float(sgs[5]))
                  avgqu_sz_day  =int(0.5+float(sgs[6]))
                  await_day  =int(0.5+float(sgs[7]))
                  svctm_day  =int(0.5+float(sgs[8]))
                  util_day =int(0.5+float(sgs[9]))

               sum_rdMB+=rdMB_day
               sum_wrMB+=wrMB_day
               sum_util+=util_day
               count+=1
               if i==1:
                  last_day_util =int(0.5+util_day)
               if i==7:
                  last_week_util=int(sum_util/float(count) +0.5)
               
               json_out+= "\"tps\": \"%d\", " %tps_day
               json_out+= "\"rdGB\": \"%d\", " %rdMB_day
               json_out+= "\"wrGB\": \"%d\", " %wrMB_day
               json_out+= "\"avgrq-sz\": \"%d\", " %avgrq_sz_day
               json_out+= "\"avgqu-sz\": \"%d\", " %avgqu_sz_day
               json_out+= "\"await\": \"%d\", " %await_day
               json_out+= "\"svctm\": \"%d\", " %svctm_day
               json_out+= "\"util\": \"%d\"" % int(util_day+0.5)
               json_out+= "},"
                  
            json_out= json_out[:-1]+"}"
            print json_out

   assettag=get_first_word("cat /etc/unitrends-asset")
   model=assettag.split("-")[0]
   if opts.csv:
      print "%d,%s,%s,%s,%d,%d,%d,%d,%d" % ( count, label, model, assettag, int( float(sum_rdMB)*365./1024./count + 0.5),
                                             int( float(sum_wrMB)*365./1024./count + 0.5),
                                             last_day_util, last_week_util, int( sum_util/float(count) +0.5))
   
   
def get_printout(command, doSplit=True):

    if opts.debug: print "# " + command
    
    import commands
    if doSplit: # To make an array
        return commands.getoutput(command).splitlines()
    else :
        return commands.getoutput(command)
      
def run_command(command, secondsToSleep=0):
   message = "Executing # %s " % command
   print message
   os.system(command)
   if secondsToSleep>0:
       import time
       time.sleep(secondsToSleep)
   return
    

def get_nth_word(command, n):
   lines = get_printout(command)
   for line in lines:
      return line.split()[n]
   return "" # this is for null return

def get_last_word(command):
   lines = get_printout(command)
   word =""
   for line in lines:
       words = line.split()
       word = words[len(words)-1]

   return word    

def get_first_word(command):
   return get_nth_word(command,0)

def print_list(list):
    for item in list:
        print item

if __name__ == '__main__':
    main()
